-- Daily Global Check
-- by Jadya
-- EU-Well of Eternity

local lower = string.lower
local addonName, addonTable = ...

local quest = DailyGlobalCheck.QuestFunctions

local instance_names = {}

local function getInstanceCompletion(instanceID, diff)
 local now = time()
 for i = 1, GetNumSavedInstances() do
  local name, _, reset, difficulty, locked, extended, _, isRaid, _, difficultyName, numEncounters, encounterProgress = GetSavedInstanceInfo(i)
  local link = GetSavedInstanceChatLink(i) or ""
  local ID = link:find(":"..instanceID..":")
  if ID and (diff == "all" or difficulty == tonumber(diff)) then
   if (locked or extended) then
    return addonTable.AddColor(encounterProgress.." / "..numEncounters, "LIGHT_GREEN"), reset
   else
    return addonTable.AddColor("["..LFG_LIST_APP_TIMED_OUT.."] "..encounterProgress.." / "..numEncounters, "GRAY"), now + 864000
   end
  end
 end
end

function quest:HasOverlay(questID)
 local qData = DailyGlobalCheck:getQData(questID)

 if not qData then return end
 
 questID = tostring(questID)

 return qData[OVERLAY] or questID:find("instance#")
end

function quest:GetOverlayInfo(questID)
 local qData = DailyGlobalCheck:getQData(questID)

 if not qData then return end
 
  -- it's an alt
 if DailyGlobalCheck.selectedpID ~= addonTable.pID then
  local c = DailyGlobalCheck_CharData[DailyGlobalCheck.selectedpID]
  if not c or not c.data or not c.data[questID] then return end
  local _, _, link = strsplit("~", c.data[questID])
  return link
 end
 
 local result
 questID = tostring(questID)
 
 -- it's the player
 if questID:find("instance#") then
  local key,arg1,arg2 = strsplit("#", questID)
  for i = 1, GetNumSavedInstances() do
   local name, _, reset, difficulty, locked, extended = GetSavedInstanceInfo(i)
   local link = GetSavedInstanceChatLink(i) or ""
   local ID = link:find(":"..arg1..":")
   if --[[(locked or extended) and ]]ID and (arg2 == "all" or difficulty == tonumber(arg2)) then
    result = link
   end
  end
 end
 return result
end

function quest:isquestcompleted(questID)
 local key,arg1,arg2,arg3 = strsplit("#", questID)
 if not key then return false end

 key = lower(key)

 if key == "instance" and arg2 then -- Instance Lockout
  local cstring, reset = getInstanceCompletion(arg1, arg2)
  if cstring then
   return true, cstring, reset
  end
 elseif key == "boss" and arg3 then -- Bosskill
  
 end
end

function quest:showTooltip(questID)
 GameTooltip:SetOwner(DGC_Mainframe, "ANCHOR_NONE")
 GameTooltip:SetPoint("LEFT", DGC_Mainframe, "RIGHT")
 GameTooltip:ClearLines()
 local result = quest:GetOverlayInfo(questID)
 if result then
  GameTooltip:SetHyperlink(result)
 end
 GameTooltip:Show()
end